<?php

namespace jrosset\ArrayClasses;

interface IArrayClass extends IImmutableArrayClass {
    /**
     * Create or replace a cell
     *
     * @param mixed $cellName  The cell name/offset
     * @param mixed $cellValue The cell new value
     *
     * @return $this
     */
    public function set ($cellName, $cellValue): self;
    /**
     * Remove a cell
     *
     * @param mixed $cellName The cell name/offset
     *
     * @return $this
     */
    public function del ($cellName): self;

    /**
     * Create an immutable copy
     *
     * @return IImmutableArrayClass The immutable copy
     */
    public function toImmutable (): IImmutableArrayClass;
}