<?php

namespace jrosset\ArrayClasses;

use ArrayAccess;
use Countable;
use IteratorAggregate;
use JsonSerializable;
use Serializable;

interface IImmutableArrayClass extends IteratorAggregate, JsonSerializable, Serializable, Countable, ArrayAccess, IArrayCast {
    /**
     * Check if a cell exists
     *
     * @param mixed $cellName The cell name/offset
     *
     * @return bool Is the cell exists ?
     */
    public function has ($cellName): bool;
    /**
     * Get the value of a cell
     *
     * @param mixed $cellName The cell name/offset
     *
     * @return mixed The cell value
     */
    public function get ($cellName);

    /**
     * Create a mutable copy
     *
     * @return IArrayClass The mutable copy
     */
    public function toMutable (): IArrayClass;
}